using Indotalent.ConfigBackEnd.Exceptions;
using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Utilities.BookingGroup.Cqrs;

public class UpdateBookingGroupRequest
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public class UpdateBookingGroupResponse
{
    public string? Id { get; set; }
    public bool Success { get; set; }
}

public record UpdateBookingGroupCommand(UpdateBookingGroupRequest Data) : IRequest<UpdateBookingGroupResponse>;

public class UpdateBookingGroupHandler : IRequestHandler<UpdateBookingGroupCommand, UpdateBookingGroupResponse>
{
    private readonly AppDbContext _context;

    public UpdateBookingGroupHandler(AppDbContext context) => _context = context;

    public async Task<UpdateBookingGroupResponse> Handle(UpdateBookingGroupCommand request, CancellationToken cancellationToken)
    {
        var isExists = await _context.BookingGroup
            .AnyAsync(x => x.Name == request.Data.Name && x.Id != request.Data.Id, cancellationToken);

        if (isExists)
        {
            throw new AlreadyExistsException("Booking Group", request.Data.Name ?? string.Empty);
        }

        var entity = await _context.BookingGroup
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null)
        {
            return new UpdateBookingGroupResponse { Id = request.Data.Id, Success = false };
        }

        entity.Name = request.Data.Name;
        entity.Description = request.Data.Description;

        await _context.SaveChangesAsync(cancellationToken);

        return new UpdateBookingGroupResponse
        {
            Id = entity.Id,
            Success = true
        };
    }
}